<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>Soprano.Util.MutexModel</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>MutexModel Class Reference</h1>
<code>from PyKDE4.soprano import *</code>
<p>
Inherits: <a href="../soprano/Soprano.FilterModel.html">Soprano.FilterModel</a> &#x2192; <a href="../soprano/Soprano.Model.html">Soprano.Model</a> &#x2192; <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />

Namespace: Soprano::Util<br />
<h2>Detailed Description</h2>

<p>\class MutexModel mutexmodel.h Soprano/Util/MutexModel
</p>
<p>
Protect a Model for multiple calls in multi-threaded
applications.
</p>
<p>
In most cases one does not need to use this FilterModel since Models
created by Soprano.createModel and Soprano.Backend.createModel
are thread-safe. It may, however, come in handy for custom models.
</p>
<p>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Sebastian Trueg &lt;trueg@kde.org&gt; </dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj184125516">ProtectionMode</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;PlainMultiThreading, ReadWriteMultiThreading, ReadWriteSingleThreading&nbsp;}</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj195268492">__init__</a> (self, Soprano.Util.MutexModel.ProtectionMode mode, <a href="../soprano/Soprano.Model.html">Soprano.Model</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Soprano.Error.ErrorCode&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj184123564">addStatement</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> statement)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj165656908">containsAnyStatement</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> statement)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192921676">containsStatement</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> statement)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../soprano/Soprano.QueryResultIterator.html">Soprano.QueryResultIterator</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192925324">executeQuery</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> query, Soprano.Query.QueryLanguage language, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> userQueryLanguage=QString())</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj165655724">isEmpty</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../soprano/Soprano.NodeIterator.html">Soprano.NodeIterator</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192925100">listContexts</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../soprano/Soprano.StatementIterator.html">Soprano.StatementIterator</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj195265708">listStatements</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> partial)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Soprano.Error.ErrorCode&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj195266636">removeAllStatements</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> statement)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Soprano.Error.ErrorCode&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj195265292">removeStatement</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> statement)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj165654892">statementCount</a> (self)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj195268492"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Soprano.Util.MutexModel.ProtectionMode&nbsp;</td>
<td class="paramname"><em>mode</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Model.html">Soprano.Model</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Create a new MutexModel.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>mode</em>&nbsp;</td><td> The mode to use.
</td></tr> </table></dl>
<p> </p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>parent</em>&nbsp;</td><td> The parent Model to forward
the actual calls to.
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj184123564"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Soprano.Error.ErrorCode addStatement</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>statement</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj165656908"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool containsAnyStatement</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>statement</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj192921676"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool containsStatement</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>statement</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj192925324"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../soprano/Soprano.QueryResultIterator.html">Soprano.QueryResultIterator</a> executeQuery</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>query</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Soprano.Query.QueryLanguage&nbsp;</td>
<td class="paramname"><em>language</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>userQueryLanguage=QString()</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj165655724"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool isEmpty</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj192925100"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../soprano/Soprano.NodeIterator.html">Soprano.NodeIterator</a> listContexts</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj195265708"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../soprano/Soprano.StatementIterator.html">Soprano.StatementIterator</a> listStatements</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>partial</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj195266636"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Soprano.Error.ErrorCode removeAllStatements</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>statement</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj195265292"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Soprano.Error.ErrorCode removeStatement</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>statement</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj165654892"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">int statementCount</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"></div></div><hr><h2>Enumeration Documentation</h2><a class="anchor" name="obj184125516"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">ProtectionMode</td>
</tr>
</table>
</div>
<div class="memdoc"><p>In PlainMultiThreading mode only one action can be performed
at the same time. Calls block until the previous call is done.
</p>
<p>
<dl class="warning" compact><dt><b>Warning:</b></dt><dd> In this mode nesting iterators will result in a deadlock.
</dd></dl>
</p><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>PlainMultiThreading</em>&nbsp;</td><td><tr><td valign="top"><em>ReadWriteMultiThreading</em>&nbsp;</td><td><tr><td valign="top"><em>ReadWriteSingleThreading</em>&nbsp;</td><td></table>
</dl>
</div></div><p>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
